var fs = require('fs');

// from npm
var superagent = require('superagent');
var errImages = [];
var reqCount = 0;
var loopCount = 0;
var cnt = 0;
var _callback;

var PngCrush = function () {
}

/**
 * Process error images.
 */
function processErrImgs() {
   loopCount++;

   if(loopCount > 8) { // max loop count
      console.log("..................Process Error Images...........:" + errImages);
      errImages = [];

      if(_callback != null) {
         _callback();
      }

      return;
   }

   if(errImages.length < 1) {
      if(_callback != null) {
         _callback();
      }
   }

   for (var i=0; i < errImages.length; i++) {
      var file = errImages.shift();

      if(!file) {
         continue;
      }

      if(file.substr(file.length - 3) == "png") {
         PngCrush.crushImg(file);
      }
   }
}

/**
 * Crush images.
 */
PngCrush.crushImg = function(path) {
   // do the request
   var req = superagent
       .post('pngcrush.com/crush')
       .attach('input', path)
   ;
   reqCount++;
   req.timeout(3000);

   // save the returned file
   req.end(function(err, res) {
      if(err || !res || !res.body) {
         errImages.push(path);
      }
      else {
         fs.writeFile(path, res.body, function(err) {
            if(err)
            console.log('Error: ' + err);
         });
      }

      reqCount--;

      if(reqCount == 0) {
         if(errImages.length > 0) {
            processErrImgs();
         }
         else if(_callback != null) {
            _callback.call();
         }
      }
   });
}

/**
 * Set callback.
 */
PngCrush.callback = function(cb) {
   _callback = cb;
}

/**
 * Reset the crush.
 */
PngCrush.resetCrush = function(cb) {
   loopCount = 0;
   errImages = [];
   reqCount = 0;
}

module.exports = PngCrush;
