var fs = require('fs');
var pngCrush = require('./pngcrush.js');

var paths = [];
var srcPaths = ["E:/source/bi/trunk/src/g5/fl/style", "E:/source/bi/trunk/src/g5/fl/air/style",
    "E:/source/bi/trunk/src/g5/h5/style", "E:/source/bi/trunk/src/g5/h5/widget",
    "E:/source/bi/trunk/src/g5/workflow", "E:/source/bi/trunk/src/g5/html",
    "E:/source/bi/trunk/src/g5/bihome/image";

/**
 * Collect png files.
 */
function collectPngs(path) {
   var items = fs.readdirSync(path);

   for (var i=0; i < items.length; i++) {
      var file = path + '/' + items[i];

      if(!file) {
         continue;
      }

      if(fs.lstatSync(file).isDirectory()) {
         collectPngs(file);
      }
      else if(file.substr(file.length - 3) == "png") {
         paths.push(file);
      }
   }
}

/**
 * Crush png files.
 */
function processCrush() {
   if(paths.length > 0) {
      // process 30 files every time
      var len = Math.min(30, paths.length);
      pngCrush.resetCrush();
      console.log("Remaining " + paths.length + " files.");

      for(var i = 0; i < len; i++) {
         pngCrush.crushImg(paths.shift());
      }
   }
   else {
      console.log("Crush Successful.");
   }
}

pngCrush.callback(processCrush);

for(var i = 0, len = srcPaths.length; i < len; i++) {
   collectPngs(srcPaths[i]);
}

processCrush();